package ru.dbotthepony.kstarbound.client.render

import org.lwjgl.glfw.GLFW.*
import ru.dbotthepony.kstarbound.client.StarboundClient
import ru.dbotthepony.kvector.vector.Vector2f

class Camera(val client: StarboundClient) {
	/**
	 * Позиция этой камеры в Starbound Unit'ах
	 */
	var pos = Vector2f()

	var pressedLeft = false
		private set

	var pressedRight = false
		private set

	var pressedUp = false
		private set

	var pressedDown = false
		private set

	fun userInput(key: Int, scancode: Int, action: Int, mods: Int) {
		when (key) {
			GLFW_KEY_LEFT -> pressedLeft = action > 0
			GLFW_KEY_RIGHT -> pressedRight = action > 0
			GLFW_KEY_UP -> pressedUp = action > 0
			GLFW_KEY_DOWN -> pressedDown = action > 0

			GLFW_KEY_C -> {
				if (action > 0) {
					client.settings.debugCollisions = !client.settings.debugCollisions

					if (client.settings.debugCollisions) {
						client.putDebugLog("Enable collsion draw")
					} else {
						client.putDebugLog("Disable collsion draw")
					}
				}
			}
		}
	}

	val velocity: Vector2f get() {
		var x = 0f
		var y = 0f

		if (pressedLeft) {
			x -= (FREEVIEW_SENS).toFloat()
		}

		if (pressedRight) {
			x += (FREEVIEW_SENS).toFloat()
		}

		if (pressedUp) {
			y += (FREEVIEW_SENS).toFloat()
		}

		if (pressedDown) {
			y -= (FREEVIEW_SENS).toFloat()
		}

		return Vector2f(x, y)
	}

	fun think(delta: Double) {
		pos += velocity * delta.toFloat()
	}

	companion object {
		const val FREEVIEW_SENS = 800.0
		const val MAX_ZOOM = 4f
		const val MIN_ZOOM = 0.1f
		const val ZOOM_STEP = 0.1f
	}
}
